//+------------------------------------------------------------------+
//|														   	 CreatePattern.mq4 |
//|																	 Sergeev Alexey |
//+------------------------------------------------------------------+
#include <WinUser32.mqh>

// parameters for data
extern string ="MA25_15"; // name for the chart file

// parameters for real data
#define NUM_BAR		6000 // number of bars for training (number of teaching patterns)
#define NUM_MA		5 // number of movings
#define DEPTH_MA	3 // number of values of a moving
#define NUM_OUT		1 // number of outputs

double MaIn[NUM_MA][DEPTH_MA]; // array of input vectors
int hFile;
//------------------------------------------------------------------ deinit
int deinit() { return(0); }
//------------------------------------------------------------------ start
int start() 
{
	string FileName = +".in";	
	// checking the presence of a file
	hFile = FileOpen(FileName, FILE_READ|FILE_BIN);
	if (hFile!=-1)
	{
		if (MessageBox("The file "+FileName+" exists. Re-write?", "Warning!", MB_YESNO|MB_ICONQUESTION)==IDNO)
			return(0);	// if refuse re-writing, then exit
	}
	// creating a file
	hFile = FileOpen(FileName, FILE_WRITE|FILE_BIN);
	FileSeek(hFile, 0, SEEK_END);

	// writing the file heading
	FileWriteInteger(hFile, NUM_BAR); // number of bars for analysis
	FileWriteInteger(hFile, NUM_MA*DEPTH_MA); // number opf elements in the pattern (dimensionality of the input vector)
	FileWriteInteger(hFile, NUM_OUT); // dimensionality of the output
	SaveInputPattern();// Set real input vectors
	SaveOutPattern(); // set output vectors
	FileClose(hFile);
	return(0);
}
//------------------------------------------------------------------ CreateInputPattern
void SaveInputPattern() // Creating array of inputs for each bar
{
	Comment("Creating arraty of inputs");
	FileSeek(hFile, 0, SEEK_END);
	int i, ma, depth;
	double op, E;
	for (i=NUM_BAR; i>0; i--) // going through bars and collecting values of MA fan
	{
		E=0.0;
		for (depth=0; depth<DEPTH_MA; depth++) //calculating moving averages
			for (ma=0; ma<NUM_MA; ma++) 
			{
				MaIn[ma][depth]=iMA(NULL, 0, 2+MathSqrt(ma*ma*ma)*3, 0, MODE_EMA, PRICE_MEDIAN, i+depth*depth)-((High[i+depth*depth]+Low[i+depth*depth])/2);
				E=E+MaIn[ma][depth]*MaIn[ma][depth]; // calculating the length of the input vector
			}
		E=MathSqrt(E); // length of the input vectot for normalizing
		for (depth=0; depth<DEPTH_MA; depth++) // normalizing and saving into a file
			for (ma=0; ma<NUM_MA; ma++) 
			{
				op=MaIn[ma][depth]/E;
				FileWriteDouble(hFile, op);
			}
	}
}
//------------------------------------------------------------------ CreateOutPattern
void SaveOutPattern() // creating array of outputs for each bar
{
	Comment("Creating array of outputs");
	FileSeek(hFile, 0, SEEK_END);
	double Up, Dn, op;
	int i;
	for (i=NUM_BAR; i>0; i--) // going through bars and collecting outputs
	{
		op=2.0;
		FileWriteDouble(hFile, op);
	}
}

